<template>
  <v-stepper v-model="step">
    <v-stepper-header>
      <v-stepper-step
        editable
        color="accent"
        step="1"
      >
        Complete los campos
      </v-stepper-step>

      <v-divider />

      <v-stepper-step
        editable
        color="accent"
        step="2"
      >
        Seleccione la fecha
      </v-stepper-step>

      <v-divider />

      <v-stepper-step
        step="3"
        editable
        color="accent"
      >
        Seleccione la hora
      </v-stepper-step>
    </v-stepper-header>
    <v-stepper-items>
      <v-card>
        <v-form ref="form" @submit.prevent="stepFunction">
          <v-stepper-content step="1">
            <v-select
              v-model="formTurno.titulo"
              :items="items"
              label="Evento"
              :rules="rules.nombre"
              required
              color="accent"
              autofocus
            />
            <v-row>
              <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
                <v-text-field
                  v-model="nombreClienteFinal"
                  disabled
                  label="Cliente"
                  type="text"
                  required
                  color="accent"
                />
              </v-col>
              <v-col>
                <v-btn
                  color="accent"
                  @click="dialogListaCliente=true"
                >
                  Seleccionar cliente
                </v-btn>
                <v-btn
                  v-if="!cliente"
                  color="secondary"
                  icon
                  :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
                  @click="dialogCliente = true"
                >
                  <v-icon
                    right
                    dark
                  >
                    fas fa-user-plus
                  </v-icon>
                </v-btn>
              </v-col>
            </v-row>
            <v-row>
              <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
                <v-text-field
                  v-model="nombreMascotaFinal"
                  disabled
                  label="Mascota"
                  type="text"
                  required
                  color="accent"
                />
              </v-col>
              <v-col>
                <v-tooltip bottom>
                  <template #activator="{ on, attrs }">
                    <v-btn
                      color="accent"
                      v-bind="attrs"
                      @click="clienteActual ? dialogListaMascota=true : dialogMascota = false"
                      v-on="clienteActual ? '' : on"
                    >
                      Seleccionar mascota
                    </v-btn>
                  </template>
                  <span>Seleccione un cliente para continuar</span>
                </v-tooltip>
                <v-tooltip v-if="!mascota" bottom>
                  <template #activator="{ on, attrs }">
                    <v-btn
                      color="secondary"
                      v-bind="attrs"
                      icon
                      :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
                      @click="clienteActual ? dialogMascota = true : dialogMascota = false"
                      v-on="on"
                    >
                      <v-icon
                        right
                        dark
                      >
                        fas fa-user-plus
                      </v-icon>
                    </v-btn>
                  </template>
                  <span>Seleccione un cliente para continuar</span>
                </v-tooltip>
              </v-col>
            </v-row>
            <v-row>
              <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
                <v-text-field
                  v-model="nombreVeterinarioFinal"
                  disabled
                  label="Veterinario"
                  type="text"
                  required
                  color="accent"
                />
              </v-col>
              <v-col>
                <v-btn
                  color="accent"
                  @click="dialogListaVeterinario=true"
                >
                  Seleccionar veterinario
                </v-btn>
                <v-btn
                  v-if="!veterinario"
                  color="secondary"
                  icon
                  :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
                  @click="dialogVeterinario = true"
                >
                  <v-icon
                    right
                    dark
                  >
                    fas fa-user-plus
                  </v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </v-stepper-content>
          <v-stepper-content step="2">
            <v-row justify="center">
              <v-date-picker v-model="formTurno.fecha" color="accent" />
            </v-row>
          </v-stepper-content>
          <v-stepper-content step="3">
            <v-row class="mt-3">
              <v-col align="center">
                <h2>Incio</h2>
              </v-col>
              <v-col align="center">
                <h2>Fin</h2>
              </v-col>
            </v-row>
            <v-row class="my-3" justify="center">
              <v-col align="center">
                <v-time-picker
                  v-model="formTurno.hora_inicio"
                  format="24hr"
                  color="accent"
                  scrollable
                />
              </v-col>
              <v-col align="center">
                <v-time-picker
                  v-model="formTurno.hora_fin"
                  format="24hr"
                  color="accent"
                  scrollable
                />
              </v-col>
            </v-row>
          </v-stepper-content>
          <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
            <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog">
              Cancelar
            </v-btn>
            <v-spacer />
            <v-btn
              color="accent"
              @click="stepFunction"
            >
              {{ step >= 3 ? 'Guardar' : 'Siguiente' }}
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-stepper-items>
    <v-dialog v-model="dialogListaCliente" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-clientes v-if="dialogListaCliente" :seleccionable="true" :cliente-seleccionado="clienteActual" @selectedCliente="actualizarCliente" />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaCliente = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogListaMascota" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-mascotas
            v-if="dialogListaMascota"
            :seleccionable="true"
            :cliente-actual="clienteActual"
            :mascota-seleccionado="mascotaActual"
            @onEdit="editarForm"
            @selectedMascota="actualizarMascota"
          />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaMascota = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogListaVeterinario" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-veterinarios v-if="dialogListaVeterinario" :seleccionable="true" :veterinario-seleccionado="veterinarioActual" @selectedVeterinario="actualizarVeterinario" />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaVeterinario = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogCliente" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-clientes v-if="dialogCliente" :form-desde-ventas="true" @onClose="dialogCliente = false" @addedCliente="actualizarCliente" />
    </v-dialog>
    <v-dialog v-model="dialogVeterinario" width="800" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-veterinarios v-if="dialogVeterinario" @onClose="dialogVeterinario = false" @addedVeterinario="actualizarVeterinario" />
    </v-dialog>
    <v-dialog v-model="dialogMascota" width="800" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-mascotas v-if="dialogMascota" :cliente-actual="clienteActual" :mascota="mascotaActual" @onClose="dialogMascota = false" @addedMascota="actualizarMascota" />
    </v-dialog>
  </v-stepper>
</template>

<script lang="ts">
import { Component, Ref, Vue } from 'vue-property-decorator'
import { Turno } from '~/core/models/turno'
import ListaClientes from '~/components/clientes/listaClientes.vue'
import { Cliente } from '~/core/models/cliente'
import FormClientes from '~/components/clientes/formClientes.vue'
import { ClientesStore } from '~/store/ClientesStore'
import FormVeterinarios from '~/components/veterinarios/formVeterinarios.vue'
import { Veterinario } from '~/core/models/veterinario'
import { VeterinariosStore } from '~/store/VeterinariosStore'
import ListaVeterinarios from '~/components/veterinarios/listaVeterinarios.vue'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { TurnosStore } from '~/store/TurnosStore'
import UpWebView from '~/components/shared/UpWebView.vue'
import { Mascota } from '~/core/models/mascota'
import { MascotasStore } from '~/store/MascotasStore'
import ListaMascotas from '~/components/mascotas/listaMascotas.vue'
import FormMascotas from '~/components/mascotas/formMascotas.vue'
@Component({
  components: { FormMascotas, ListaMascotas, UpWebView, ListaVeterinarios, FormVeterinarios, FormClientes, ListaClientes }
})
export default class formTurnos extends Vue {
  @Ref('form') formulario;

  step = 1;
  clienteActual:Cliente = null;
  dialogListaCliente:boolean =false;
  dialogCliente:boolean = false;
  veterinarioActual:Veterinario = null;
  dialogListaVeterinario:boolean =false;
  dialogVeterinario:boolean = false;
  dialogMascota:boolean = false;
  dialogListaMascota:boolean =false;
  mascotaActual:Mascota = null;

  items= ['Vacunación', 'Operación', 'Baño', 'Corte', 'Corte + Baño', 'Consulta']

  formTurno:Turno = {
    fecha: '',
    hora_fin: '',
    hora_inicio: '',
    titulo: '',
    clientes_idclientes: null,
    veterinarios_idveterinarios: null,
    mascotas_idmascotas: null
  }

  rules = {
    nombre: [
      v => !!v || 'Campo requerido'
    ],
    dni: [
      v => !!v || 'Campo requerido',
      v => /^[0-9]*$/.test(v) || 'Solo debe ingresar números',
      v => /^[0-9]{5,15}$/.test(v) || 'El número no alcanza el mínimo de dígitos o supera el máximo de dígitos'
    ],
    email: [
      v => !!v || 'Campo requerido',
      v => /.+@.+/.test(v) || 'E-mail inválido'
    ]
  };

  get nombreClienteFinal ():string {
    return this.clienteActual ? this.clienteActual.nombre : 'Por favor seleccione un cliente'
  }

  get cliente ():Cliente {
    return this.formTurno.clientes_idclientes && ClientesStore.listaClientes.find(p => p.idclientes === this.formTurno.clientes_idclientes)
  }

  get nombreVeterinarioFinal ():string {
    return this.veterinarioActual ? this.veterinarioActual.name : 'Por favor seleccione un veterinario'
  }

  get nombreMascotaFinal ():string {
    return this.mascota ? this.mascota.nombre : 'Por favor seleccione una mascota'
  }

  get mascota ():Mascota {
    return this.formTurno.mascotas_idmascotas && MascotasStore.mascotas.find(p => p.idmascotas === this.formTurno.mascotas_idmascotas)
  }

  get veterinario ():Veterinario {
    return this.formTurno.veterinarios_idveterinarios && VeterinariosStore.listaVeterinarios.find(p => p.idveterinarios === this.formTurno.veterinarios_idveterinarios)
  }

  actualizarCliente (cliente:Cliente) {
    if (cliente) {
      this.clienteActual = cliente
      this.formTurno.clientes_idclientes = cliente.idclientes
      this.actualizarMascota(null)
    } else {
      this.clienteActual = null
      this.formTurno.clientes_idclientes = null
      this.actualizarMascota(null)
    }
    this.dialogListaCliente = false
  }

  actualizarVeterinario (veterinario:Veterinario) {
    this.dialogListaVeterinario = false
    if (veterinario) {
      this.veterinarioActual = veterinario
      this.formTurno.veterinarios_idveterinarios = veterinario.idveterinarios
    } else {
      this.veterinarioActual = null
      this.formTurno.veterinarios_idveterinarios = null
    }
  }

  editarForm (val) {
    this.mascotaActual = val
    this.dialogMascota = true
  }

  actualizarMascota (mascota:Mascota) {
    if (mascota) {
      this.mascotaActual = mascota
      this.formTurno.mascotas_idmascotas = mascota.idmascotas
    } else {
      this.mascotaActual = null
      this.formTurno.mascotas_idmascotas = null
    }
    this.dialogListaMascota = false
  }

  stepFunction () {
    if (this.step >= 3) {
      this.validarFormulario()
    } else {
      this.step += 1
    }
  }

  validarFormulario () {
    if (this.formulario.validate()) {
      this.guardar()
    } else {
      AppToast.error('Campos incompletos')
    }
  }

  private async guardar () {
    AppStore.SHOW_LOADING('Guardando Turno')
    try {
      await TurnosStore.registrarTurno(this.formTurno)
      this.imprimirTurno(this.formTurno.clientes_idclientes)
      this.cerrarDialog()
      AppToast.success('Turno registrado')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }

  imprimirTurno (idclientes) {
    this.$emit('onImprimir', idclientes)
  }

  cerrarDialog () {
    this.$emit('onClose')
  }
}
</script>

<style lang="scss">

</style>
